/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */
package org.apache.qpid.server.message;

import java.util.Date;
import java.util.Map;

import org.apache.qpid.server.model.ManagedAttributeValue;
import org.apache.qpid.server.model.ManagedAttributeValueType;

@ManagedAttributeValueType
public interface MessageInfo extends ManagedAttributeValue
{
    long getId();
    long getSize();
    long getHeaderSize();
    String getMessageType();
    int getDeliveryCount();
    String getState();
    String getDeliveredTo();
    String getDeliveredToConsumerId();
    Date getArrivalTime();
    boolean isPersistent();
    String getMessageId();
    Date getExpirationTime();
    String getApplicationId();
    String getCorrelationId();
    String getEncoding();
    String getMimeType();
    int getPriority();
    String getReplyTo();
    Date getTimestamp();
    String getType();
    String getUserId();
    String getGroupId();
    Map<String,Object> getHeaders();
    Date getNotValidBefore();
    String getInitialRoutingAddress();
    String getTo();
}
