/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP version:
 *   8-0
 */

package org.apache.qpid.server.protocol.v0_8.transport;

import org.apache.qpid.server.QpidException;
import org.apache.qpid.server.bytebuffer.QpidByteBuffer;
import org.apache.qpid.server.protocol.ProtocolVersion;
import org.apache.qpid.server.protocol.v0_8.AMQShortString;

public class ConnectionRedirectBody extends AMQMethodBodyImpl implements EncodableAMQDataBlock, AMQMethodBody
{
    private final int _ownMethodId;

    public static final int CLASS_ID =  10;

    // Fields declared in specification
    private final AMQShortString _host; // [host]
    private final AMQShortString _knownHosts; // [knownHosts]


    public ConnectionRedirectBody(ProtocolVersion protocolVersion, AMQShortString host, AMQShortString knownHosts)
    {
        _ownMethodId = ProtocolVersion.v0_8.equals(protocolVersion) ? 50 : 42;
        _host = host;
        _knownHosts = knownHosts;
    }

    @Override
    public int getClazz()
    {
        return CLASS_ID;
    }

    @Override
    public int getMethod()
    {
        return _ownMethodId;
    }

    public final AMQShortString getHost()
    {
        return _host;
    }
    public final AMQShortString getKnownHosts()
    {
        return _knownHosts;
    }

    @Override
    protected int getBodySize()
    {
        int size = 0;
        size += getSizeOf( _host );
        size += getSizeOf( _knownHosts );
        return size;
    }

    @Override
    public void writeMethodPayload(QpidByteBuffer buffer)
    {
        writeAMQShortString( buffer, _host );
        writeAMQShortString( buffer, _knownHosts );
    }

    @Override
    public boolean execute(MethodDispatcher dispatcher, int channelId) throws QpidException
	{
        return dispatcher.dispatchConnectionRedirect(this, channelId);
	}

    @Override
    public String toString()
    {
        StringBuilder buf = new StringBuilder("[ConnectionRedirectBodyImpl: ");
        buf.append( "host=" );
        buf.append(  getHost() );
        buf.append( ", " );
        buf.append( "knownHosts=" );
        buf.append(  getKnownHosts() );
        buf.append("]");
        return buf.toString();
    }

    public static void process(final QpidByteBuffer buffer, final ClientMethodProcessor dispatcher)
    {
        AMQShortString host = AMQShortString.readAMQShortString(buffer);
        AMQShortString knownHosts = AMQShortString.readAMQShortString(buffer);
        if(!dispatcher.ignoreAllButCloseOk())
        {
            dispatcher.receiveConnectionRedirect(host, knownHosts);
        }
    }
}
