/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.qpid.disttest.jms;

import java.util.List;

import javax.jms.Connection;
import javax.jms.Session;

import org.apache.qpid.disttest.controller.config.QueueConfig;

public class NoOpQueueCreator implements QueueCreator
{
    @Override
    public void createQueues(Connection connection, Session session, List<QueueConfig> configs)
    {
    }

    @Override
    public void deleteQueues(Connection connection, Session session, List<QueueConfig> configs)
    {
    }

    @Override
    public String getProtocolVersion(final Connection connection)
    {
        return null;
    }

    @Override
    public String getProviderVersion(final Connection connection)
    {
        return null;
    }
}
