/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */
package org.apache.qpid.tests.protocol.v1_0.extensions.type;

import org.apache.qpid.server.protocol.v1_0.type.messaging.Filter;

public class TestFilter implements Filter
{
    private final String _value;

    public TestFilter(String value)
    {
        _value = value;
    }

    public String getValue()
    {
        return _value;
    }

    @Override
    public String toString()
    {
        return "TestFilter{" + _value + '}';
    }

    @Override
    public boolean equals(Object o)
    {
        if (this == o)
        {
            return true;
        }
        if (o == null || getClass() != o.getClass())
        {
            return false;
        }

        TestFilter that = (TestFilter) o;

        return _value != null ? _value.equals(that._value) : that._value == null;
    }

    @Override
    public int hashCode()
    {
        return _value != null ? _value.hashCode() : 0;
    }
}
